<?php
	/***************************************************************
	*  Copyright notice
	*
	*  (c) 2005 Rainer Sudhoelter <r.sudhoelter (at) web.de>
	*  All rights reserved
	*
	*  This script is part of the TYPO3 project. The TYPO3 project is
	*  free software; you can redistribute it and/or modify
	*  it under the terms of the GNU General Public License as published by
	*  the Free Software Foundation; either version 2 of the License, or
	*  (at your option) any later version.
	*
	*  The GNU General Public License can be found at
	*  http://www.gnu.org/copyleft/gpl.html.
	*
	*  This script is distributed in the hope that it will be useful,
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	*  GNU General Public License for more details.
	*
	*  This copyright notice MUST APPEAR in all copies of the script!
	***************************************************************/
	/**
	 * Module 'import' for the 'rs_userimp' extension.
	 * @author	Rainer Sudhoelter <r.sudhoelter (at) web.de>
	 *	@comment Parts of this class (presets handling) are derived from SYSEXT:impexp written by Kasper Skarhoe
	 */
	/**
	 * [CLASS/FUNCTION INDEX of SCRIPT]
	 *
	 *
	 *
	 *   86: class tx_rsuserimp_module1 extends t3lib_SCbase
	 *   94:     function init()
	 *  112:     function menuConfig()
	 *  131:     function main()
	 *  152:     function jumpToUrl(URL)
	 *  161:     function swapPresetSelectFields()
	 *  211:     function printContent()
	 *  222:     function moduleContent()
	 *  759:     function getFEuserFolder ()
	 *  776:     function getFEuserGroup ()
	 *  792:     function getRollbackDataSets ()
	 *  812:     function getRollbackDataSet ($uid)
	 *  831:     function fieldSelector($n)
	 *  851:     function checkUpload()
	 *  882:     function getPresets()
	 *  900:     function processPresets(&$inData)
	 *  992:     function getPreset($uid)
	 *
	 *              SECTION: Generel Helper functions
	 * 1008:     function userTempFolder()
	 * 1027:     function makeSaveForm($inData, &$row)
	 * 1085:     function renderMultipleSelector($prefix,$allValues,$postData,$reverse=0)
	 * 1148:     function renderSelectBox($prefix,$value,$optValues,$id='')
	 * 1171:     function gc($garbageCollectionTriggerTime,$rollbackSafetyTimespan)
	 *
	 * TOTAL FUNCTIONS: 21
	 * (This index is automatically created/updated by the extension "extdeveval")
	 *
	 */

	// DEFAULT initialization of a module [BEGIN]
	unset($MCONF);
	require_once ('conf.php');
	require_once ($BACK_PATH.'init.php');
	require_once ($BACK_PATH.'template.php');
	require_once (PATH_t3lib.'class.t3lib_scbase.php');
	require_once (PATH_t3lib.'class.t3lib_basicfilefunc.php');
	require_once (PATH_t3lib.'class.t3lib_extfilefunc.php');

	//require_once(PATH_t3lib.'class.t3lib_pagetree.php');
	//require_once(PATH_t3lib.'class.t3lib_browsetree.php');

	require_once(t3lib_extMgm::extPath('rs_userimp').'mod1/class.tx_rsuserimp.php');
	$LANG->includeLLFile('EXT:rs_userimp/mod1/locallang.php');

	$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

		/**
 * Extends the "ScriptClasses" for backend modules to hold this module
 *
 */
	class tx_rsuserimp_module1 extends t3lib_SCbase {
		var $pageinfo;

		/**
 * Initializes the module
 *
 * @return	void		standard initialization of BE modul
 */
		function init()	{
			global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

			parent::init();

			/*
			if (t3lib_div::_GP("clear_all_cache"))	{
				$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
			}
			*/
			//$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}

		/**
 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
 *
 * @return	void
 */
		function menuConfig()	{
			global $LANG;
			$this->MOD_MENU = Array (
				"function" => Array (
					"1" => $LANG->getLL("function1"),
					"2" => $LANG->getLL("function2"),
					"3" => $LANG->getLL("function3"),
				)
			);
			parent::menuConfig();
		}

		// If you chose "web" as main module, you will need to consider the $this->id
		// parameter which will contain the uid-number of the page clicked in the page tree
		/**
 * Main function of the module. Write the content to $this->content
 *
 * @return	void
 */
		function main()	{
			global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

			// Access check!
			// The page will show only if there is a valid page and if this page may be viewed by the user
			$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
			$access = is_array($this->pageinfo) ? 1 : 0;

			if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{

				// Draw the header.
				$this->doc = t3lib_div::makeInstance("mediumDoc");
				$this->doc->backPath = $BACK_PATH;

				$this->doc->form = '<form name="rs_userimp" action="index.php" method="post" enctype="'.$GLOBALS['TYPO3_CONF_VARS']['SYS']['form_enctype'].'">
											<input type="hidden" name="id" value="'.$this->id.'" />';

					// JavaScript
				$this->doc->JScode = '
					<script language="javascript" type="text/javascript">
						script_ended = 0;
						function jumpToUrl(URL)	{
							document.location = URL;
						}

						/**
 * Javascript function: clears text field if select box is not empty.
 *
 * @return	void
 */
						function swapPresetSelectFields() {
							var one = document.rs_userimp.swapfield.value;
							if(one != "") {
								document.rs_userimp.swapfield.value = 0;
							}
						}
					</script>
					<script src="scripts.js" type="text/javascript" language="Javascript" charset="iso-8859-1"></script>
					';

				$this->doc->postCode = '
					<script language="javascript" type="text/javascript">
						script_ended = 1;
						if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
					</script>';

				$this->doc->JScode .= $this->doc->getDynTabMenuJScode();

				$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

				$this->content .= $this->doc->startPage($LANG->getLL("title"));
				$this->content .= $this->doc->header($LANG->getLL("title"));
				$this->content .= $this->doc->section('',$this->doc->funcMenu('',t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
				$this->content .= $this->doc->spacer(5);

				// Render content:
				$this->moduleContent();
				// ShortCut
				if ($BE_USER->mayMakeShortcut())	{
					$this->content.=$this->doc->spacer(5).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
				}
				$this->content.=$this->doc->spacer(5);
			} else {

				// If no access or if ID == zero

				$this->doc = t3lib_div::makeInstance("mediumDoc");
				$this->doc->backPath = $BACK_PATH;

				$this->content .= $this->doc->startPage($LANG->getLL("title"));
				$this->content .= $this->doc->header($LANG->getLL("title"));
				$this->content .= $this->doc->spacer(5);
			}
		}

		/**
 * Prints out the module HTML
 *
 * @return	void		prints HTML content
 */
		function printContent()	{

			$this->content .= $this->doc->endPage();
			echo $this->content;
		}

		/**
 * Generates the module content
 *
 * @return	void
 */
		function moduleContent()	{

			global $LANG, $TCA, $TCA_DESCR, $BE_USER;

			// get configuration values from ext_conf_template.txt
			$userimpConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['rs_userimp']);

			// get all GP data for extension
			$inData = t3lib_div::_GP('tx_rsuserimp');

			$useRecycler = $userimpConf['useRecycler'];
			$createDropFile = $userimpConf['createDropFile'];
			$garbageCollectionTriggerTime = $userimpConf['garbageCollectionTriggerTime'];

			$rollbackSafetyTimespan = $userimpConf['rollbackSafetyTimespan'];
			$rollbackPreviewRows = $userimpConf['rollbackPreviewRows'];
			$rollbackDeleteFromDB = $userimpConf['rollbackDeleteFromDB'];

			//garbage collection
			$this->gc($garbageCollectionTriggerTime,$rollbackSafetyTimespan);

			$newFile = $this->checkUpload();

			if ($inData['settings']['uploadfile']) {
				$absFile = $inData['settings']['uploadfile'];
			}

			if (!empty($newFile)) {
				$absFile = $inData['settings']['uploadfile'] = $newFile;
				$inData = '';
			}

			switch((string)$this->MOD_SETTINGS["function"])	{

				case 3:
					$content .= $this->doc->section($LANG->getLL('f3.securityNote'),'',0,1,1);
					$content .= '<table border="0" width="100%" align="center" bgcolor="' . $this->doc->bgColor4 . '">';
					$content .= '<tr>
										<td>'.$LANG->getLL('f3.securityNote.message').'</td>
									 </tr>';

//					$content .= '<table border="0" width="100%" align="center">';
//					$content .= '<tr class="tableheader bgColor5">
//							<td colspan="2">'.$LANG->getLL('f1.tab1.section.importFile').'</td>
//						</tr>';
					$content .= '</table>';
					$this->content .= $content;

//'f3.securityNote.message'
					break;

				case 2:
					if (is_array($inData['rollback'])) {
						$rollbackSession = array_keys($inData['rollback']);
						if ($rollbackSession[0] != '') {
							$data = $this->getRollbackDataSet($rollbackSession[0]);
							$info = explode(',', $data['session_data']);
						}
						foreach ($info as $del) {
							if ($rollbackDeleteFromDB) {
								$GLOBALS['TYPO3_DB']->exec_DELETEquery('fe_users','uid='.$del);
								$BE_USER->writelog(1,3,0,'','UID %s deleted by CSV rollback action',Array($del)); //TCEmain
							} else {
								$GLOBALS['TYPO3_DB']->exec_UPDATEquery('fe_users','uid='.$del,array('deleted'=>'1'));
							}
						}
						$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_rsuserimp_sessions','uid='.$rollbackSession[0],array('active'=>'0'));
					}

					$rollbackData = $this->getRollbackDataSets();

					if (!empty($rollbackData)) {
						$content .= '<table name="sessionlist" id="sessionlist" border="0" width="100%" cellspacing="1" cellpadding="2" align="center" bgcolor="' . $this->doc->bgColor2 . '">';
						$content .= '<tr>
											<td><strong>'.$LANG->getLL('f2.session').'</strong></td>
											<td><strong>'.$LANG->getLL('f2.date').'</strong></td>
											<td><strong>'.$LANG->getLL('f2.title').'</strong></td>
											<td><strong>'.$LANG->getLL('f2.status').'</strong></td>
										 </tr>';

						$rowcount = 0;
						$colorcount = 0;

						foreach ($rollbackData as $session) {
							$info = explode(',', $session['session_data']);
							$rollbacktime = $session['crdate'] + 60*$rollbackSafetyTimespan;
							$createtime = getdate($session['crdate'][0]);

							$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username','be_users','uid='.$session['user_uid'].'');
							$row = $GLOBALS['TYPO3_DB']->sql_fetch_row($res);
							if ($GLOBALS['TYPO3_DB']->sql_affected_rows() == 1) {
								$username = $row[0];
							} elseif ($GLOBALS['TYPO3_DB']->sql_affected_rows() == 0) {
								$username = 'user deleted';
							} else {
								$username = 'unknown';
							}

							$infoBlock = '<strong>'.$LANG->getLL('f2.importSummary',1).'</strong>:<br>
							<div align="left">
								<table cellpadding="0px" cellspacing="0px" border="0">
									<tr>
										<td>'.$LANG->getLL('f2.importFile',1).'</td>
										<td width="10pt"></td>
										<td>'.$session['file'].'</td>
									</tr>
									<tr>
										<td>'.$LANG->getLL('f2.importedBy',1).'</td>
										<td width="10pt"></td>
										<td>UID '.$session['user_uid'].' ['.$username.']</td>
									</tr>
									<tr>
										<td>'.$LANG->getLL('f2.userType',1).'</td>
										<td width="10pt"></td>
										<td>'.$session['usertype'].'</td>
									</tr>
									<tr>
										<td>'.$LANG->getLL('f2.usersImported',1).'</td>
										<td width="10pt"></td>
										<td>'.$session['num_imp'].'</td>
									</tr>
									<tr>
										<td>'.$LANG->getLL('f2.usersDropped',1).'</td>
										<td width="10pt"></td>
										<td>'.$session['num_drop'].(!empty($session['dropfile']) && is_file($session['dropfile']) ? ' [<a href="/uploads/tx_rsuserimp/'.basename($session['dropfile']).'">'.$LANG->getLL('f1.tab5.downloadFile').'</a>]' : '').'</td>
									</tr>
								</table>
							</div>';

							$infoBlock .= '<br><strong>'.$LANG->getLL('f2.sampleData',1).'</strong><br><br>';

							$previewNum = ($rollbackPreviewRows < count($info)) ? $rollbackPreviewRows : count($info);

							for ($i = 0 ; $i<$previewNum ; $i++) {
								$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username','fe_users','uid='.$info[$i].'');
								$row = $GLOBALS['TYPO3_DB']->sql_fetch_row($res);
								if ($GLOBALS['TYPO3_DB']->sql_affected_rows() == 1) {
									$infoBlock .= $row[0].' [UID '.$info[$i].']<br>';
								} elseif ($GLOBALS['TYPO3_DB']->sql_affected_rows() == 0) {
									$infoBlock .= sprintf($LANG->getLL('f2.userAlreadyDeleted'),$info[$i]).'<br>';
								} else {
									$infoBlock .= $LANG->getLL('f2.unknownError').'<br>';
								}
							}

							$infoBlock .= '[...]<br>';
							$infoBlock .= '<div align="right">
													<input type="submit" onclick="return confirm(\''.$LANG->getLL('f2.rollback.sure',1).'\');" name="tx_rsuserimp[rollback]['.$session['uid'].']" value="Roll back" '.((((mktime() < $rollbacktime) || $rollbackSafetyTimespan == 0) && $session['active'] == 1) ? '' : 'disabled').'/>
												</div>';

							$colorcount = ($colorcount == 1) ? 0: 1;
							$color = ($colorcount == 1) ? $this->doc->bgColor5 : $this->doc->bgColor4;
							$tr_params = ' onmouseover="setRowColor(this,\'' . $rowcount . '\',\'over\',\'' . $this->doc->bgColor6 . '\');"
												onclick="setRowColor(this,\'' . $rowcount . '\',\'click\',\'' . $this->doc->bgColor6 . '\',\'' . $color . '\');" bgcolor="' . $color . '"
												onmouseout="setRowColor(this,\'' . $rowcount . '\',\'out\',\'' . $color . '\',\'' . $this->doc->bgColor6 . '\');"
												';
							//t3lib_userauth patched for devLog!!!
							$content .= '<tr' . $tr_params . ' id="sessionrow_'.$rowcount.'" name="sessionrow" style="cursor: pointer;">
											<td valign="top"><strong>'.$session['uid'].'</td>
											<td valign="top">'.t3lib_befunc::dateTimeAge($session['crdate'],1).'</td>
											<td valign="top">'.$session['title'].'</td>';

							$now = mktime();

							if ($now < $rollbacktime || $rollbackSafetyTimespan == 0) {
								if ($session['active'] == 1) {
									$content .= '<td valign="top">'.sprintf($LANG->getLL('f2.sessionRollback'),t3lib_befunc::dateTimeAge($rollbacktime,1)).'</td>';
								}

								if ($session['active'] == 0) {
									$content .= '<td valign="top">'.$LANG->getLL('f2.sessionRolledBack').'</td>';
								}
							} elseif ($now >= $rollbacktime) {
									$content .= '<td valign="top">'.sprintf($LANG->getLL('f2.sessionExpired'),t3lib_befunc::dateTimeAge($rollbacktime,1)).'</td>';
							}

							$content .= '</tr>';
							$content .= '<tr style="display: none;" id="rs_userimp_be_rollbacksession_'.$rowcount.'" bgcolor="'.$this->doc->bgColor6.'">
												<td colspan="5">'.$infoBlock.'</td>
											</tr>';
							$rowcount++;
						} //end foreach
						$content .= '</table>';
						} else { //if not empty rollbackData
							$this->content.= $this->doc->section($LANG->getLL('f2.noSessionFound'),'',0,1,1);
						}

						$this->content .= $content;

					break;

				case 1:
			/***** start ********/
			/***** file uplod ********/
			/**** TAB 1 data *****/

					/* create instance of the mapping object */

					$additionalMandatoryFieldsFE = $inData['settings']['extraFields'];//array_unique(t3lib_div::trimExplode(',',$userimpConf['additionalMandatoryFieldsFE'],1));

					$mapper = t3lib_div::makeInstance("tx_rsuserimp");
					$mapper->init();

					$dbFieldsDefault = explode(',',$TCA['fe_users']['feInterface']['fe_admin_fieldList']);

					$mapper->removeNoMapFields(&$dbFieldsDefault);

					$dbFieldsDefault = array_diff($dbFieldsDefault,$mapper->mandatoryFields);

					$row[] = '
						<input type="hidden" name="tx_rsuserimp[settings][uploadfile]" value="'.$absFile.'" />';

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab1.section.importFile').'</td>
						</tr>';

					$tempDir = $this->userTempFolder();
					$row[] = '
						<tr class="bgColor4">
							<td><strong>'.$LANG->getLL('f1.tab1.section.importFile.importFile').'</strong></td>
							<td>'.
								$LANG->getLL('importFile').'<br/>
								<input type="file" name="upload_1" size="30" '.($_POST['importNow'] ? 'disabled' : '').'/><br/>
								<input type="hidden" name="file[upload][1][target]" value="'.htmlspecialchars($tempDir).'" '.($_POST['importNow'] ? 'disabled' : '').'/>
								<input type="hidden" name="file[upload][1][data]" value="1" />
								'.$LANG->getLL('f1.tab1.section.importFile.overwriteFile').'
								<input type="checkbox" name="tx_rsuserimp[preset][overwriteExistingFiles]" value="1"'.($inData[preset]['overwriteExistingFiles'] ? ' checked="checked"' : '').' '.($_POST['importNow'] ? 'disabled' : '').'/><br/>
								<div align="right"><input type="submit" value="Upload" '.($_POST['importNow'] ? 'disabled' : '').'/></div>
							</td>
						</tr>';

					if (!empty($absFile) && file_exists($absFile)) {
						$currentFileInfo = t3lib_basicFileFunctions::getTotalFileInfo($absFile);
						$currentFile = $currentFileInfo['file'];
						$curentFileSize = t3lib_basicFileFunctions::formatSize($currentFileInfo['size']);
						$currentFileMessage = $currentFile.' ('.$curentFileSize.')';
					} else {
						$currentFileMessage = $LANG->getLL('f1.tab1.section.importFile.emptyImportFile');
					}

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab1.section.importFile.currentImportFile').'</strong></td>
								<td><div align="left"><strong>'.$currentFileMessage.'</strong></div></td>
							</tr>';

					//now, compose TAB menu array for TAB1
					$menuItems[] = array(
						'label' => $LANG->getLL('f1.tab1'),
						'content' => '
							<table border="0" cellpadding="1" cellspacing="1" width="100%">
								'.implode('
								',$row).'
							</table>
						',
						'description' => $LANG->getLL('f1.tab1.description'),
						'linkTitle' => '',
						'stateIcon' => $absFile ? -1 : 2
					);
			/**** TAB 1 data *****/


			/***** start ********/
			/***** general import ********/
			/**** TAB 2 data *****/

					$this->processPresets(&$inData);

					$row = array();

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab2.section.userType').'</td>
						</tr>';

					// define options for usertype dropdown menu
	//				$opt = array('FE'=>$LANG->getLL('f1.tab2.constants.FE'),"BE"=>$LANG->getLL('f1.tab2.constants.BE'));
					$opt = array('FE'=>$LANG->getLL('f1.tab2.constants.FE'));
					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.userType.label').'</strong></td>
								<td>'.$this->renderSelectBox('tx_rsuserimp[settings][importUserType]',($inData['settings']['importUserType'] ? $inData['settings']['importUserType'] : ''),$opt).'</td>
							</tr>';

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab2.section.storageFolder').'</td>
						</tr>';

					$preopt = $this->getFEuserFolder();
					$opt = array(''=>'');

					foreach ($preopt as $val) {
						$opt = $opt + array($val['uid'] => $val['title'].' [UID '.$val['uid'].']');
					}

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.storageFolder.label').'</strong></td>
								<td>'.$this->renderSelectBox('tx_rsuserimp[settings][importStorageFolder]',($inData['settings']['importStorageFolder'] ? $inData['settings']['importStorageFolder'] : ''),$opt).'</td>
							</tr>';

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab2.section.defaultGroup').'</td>
						</tr>';

					$preopt = $this->getFEuserGroup();
//require_once('debuglib.php');

					if (!empty($preopt)) {
						$opt = array();
//						$opt = array(''=>'');
						foreach ($preopt as $key=>$val) {
							$opt = $opt + array($val['uid'] => $val['title'].' [UID '.$val['uid'].']');
//							$opt[$key] = $val['title'].' [UID '.$val['uid'].']';
						}
					} else {
						$opt = array(''=>$LANG->getLL('f1.tab2.section.defaultGroup.emptyGroup'));
					}
//print_r('Options as read from DB<br>');
//print_a($opt);
//print_r('<br>Options as posted via form<br>');
//print_a($inData['settings']['importUserGroup']);

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.defaultGroup.label').'</strong></td>
								<td>'.$this->renderMultipleSelector('tx_rsuserimp[settings][importUserGroup]',$opt,$inData['settings']['importUserGroup'],1).'</td>
							</tr>';

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab2.section.generalSettings').'</td>
						</tr>';

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.firstRowHasFieldnames').'</strong></td>
								<td><input type="checkbox" name="tx_rsuserimp[settings][firstRowHasFieldnames]" value="1"'.($inData['settings']['firstRowHasFieldnames'] ? ' checked="checked"' : '').' '.($_POST['importNow'] ? 'disabled' : '').'/></td>
							</tr>';

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.enableAutoRename').'</td>
								<td><input type="checkbox" name="tx_rsuserimp[settings][enableAutoRename]" value="1"'.($inData['settings']['enableAutoRename'] ? ' checked="checked"' : '').' '.($_POST['importNow'] ? 'disabled' : '').'/></td>
							</tr>';

					// define options for fieldDelimiter dropdown menu
					$opt = array(';'=>$LANG->getLL('f1.tab2.constants.semicolon'),','=>$LANG->getLL('f1.tab2.constants.comma'),':'=>$LANG->getLL('f1.tab2.constants.colon'),'TAB'=>$LANG->getLL('f1.tab2.constants.tab'));
					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.fieldDelimiter').'</strong></td>
								<td>'.$this->renderSelectBox('tx_rsuserimp[settings][fieldDelimiter]',($inData['settings']['fieldDelimiter'] ? $inData['settings']['fieldDelimiter'] : ''),$opt).'</td>
							</tr>';

					// define options for fieldEncaps dropdown menu$opt = array(';',',',':');
					$opt = array(''=>"",'"'=>'"',"'"=>"'");
					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.fieldEncaps').'</strong></td>
								<td>'.$this->renderSelectBox('tx_rsuserimp[settings][fieldEncaps]',($inData['settings']['fieldEncaps'] ? $inData['settings']['fieldEncaps'] : ''),$opt).'</td>
							</tr>';

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.previewNum').'</strong></td>
								<td><input type="select" name="tx_rsuserimp[settings][maxPreview]" value="'.htmlspecialchars($inData['settings']['maxPreview']).'" size="2" maxlength="2" '.($_POST['importNow'] ? 'disabled' : '').'></td>
							</tr>';

					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab2.section.generalSettings.additionalMandatoryFields').'</td>
						</tr>';

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.additionalMandatoryFields.description').'</strong></td>
								<td>'.$this->renderMultipleSelector('tx_rsuserimp[settings][extraFields]',$dbFieldsDefault,$inData['settings']['extraFields']).'</td>
							</tr>';

					$row[] = '
							<tr class="bgColor4">
								<td><strong>'.$LANG->getLL('f1.tab2.section.generalSettings.update').'</strong></td>
								<td><div align="right"><input type="submit" name="tx_rsuserimp[settings][OK]" value="'.$LANG->getLL('f1.tab2.section.generalSettings.update.update',1).'" '.($_POST['importNow'] ? 'disabled' : '').'/></div></td>
							</tr>';

					$this->makeSaveForm($inData, $row); //call by reference, alters the array(row) !!!

					//now, compose TAB menu array for TAB2
					$menuItems[] = array(
						'label' => $LANG->getLL('f1.tab2'),
						'content' => $absFile ? '
							<table border="0" cellpadding="1" cellspacing="1" width="100%">
								'.implode('
								',$row).'
							</table>
						' : '',
						'description' => $LANG->getLL('f1.tab2.description'),
						'linkTitle' => '',
						'toggle' => 0,
						'stateIcon' => $inData['settings']['OK'] ? -1 : 0
					);
			/**** TAB 2 data *****/

			/***** start ********/
			/***** field mapping ********/
			/**** TAB 3 data *****/

					$row = array();

					if ($inData['settings']['OK']) {
						$mapper->file = $absFile;
						$mapper->previewNum = $inData['settings']['maxPreview'];
						$mapper->CSVhasTitle = $inData['settings']['firstRowHasFieldnames'];
						$mapper->fieldDelimiter = $inData['settings']['fieldDelimiter'];
						$mapper->fieldEncaps = $inData['settings']['fieldEncaps'];
						$mapper->defaultUserData['pid'] = $inData['settings']['importStorageFolder'];
						$mapper->defaultUserData['usergroup'] = implode(',',$inData['settings']['importUserGroup']);
//print_r(implode(',',$inData['settings']['importUserGroup']));
//print_r($inData['settings']['importUserGroup']);
						$mapper->userType = $inData['settings']['importUserType'];
						$mapper->enableAutoRename = $inData['settings']['enableAutoRename'];
						$mapper->createDropFile = $createDropFile;
//print_a($additionalMandatoryFieldsFE);
						$mapper->additionalMandatoryFieldsFE = $additionalMandatoryFieldsFE;
						$mapper->inData = $inData;
						$mapper->useRecycler = $useRecycler;
						$mapper->start();

						$row[] = '
								<input type=hidden name="tx_rsuserimp[settings][OK]" value="Update">';

						$row[] = '
								<tr class="bgColor4">'.$mapper->createMappingForm().
								'</tr>';
					}

					$menuItems[] = array(
						'label' => $LANG->getLL('f1.tab3'),
						'content' => ($inData['settings']['OK'] || t3lib_div::_GP('map')) ? '
							<table border="0" cellpadding="1" cellspacing="1" width="100%">
								'.implode('
								',$row).'
							</table>
						' : '',
						'description' => $LANG->getLL('f1.tab3.description'),
						'linkTitle' => '',
						'toggle' => 0,
						'stateIcon' => (!empty($mapper->importOK) || $inData['fieldmap']['OK']) ? -1 : 0
					);
			/**** TAB 3 data *****/


			/***** start ********/
			/***** importOK ********/
			/**** TAB 4 data *****/
				$row = array();

				if (!empty($mapper->importOK)) {
					$row[] = '
						<tr class="tableheader bgColor5">
							<td colspan="2">'.$LANG->getLL('f1.tab4.section.import').'</td>
						</tr>';

					$row[] = '
							<tr class="bgColor4"><td>' .$mapper->createImportForm().
							'</td></tr>';
				}

				if ($mapper->importNow == 'TRUE') {
					$msg = $mapper->importUsers();
				}

				$menuItems[] = array(
					'label' => $LANG->getLL('f1.tab4'),
					'content' => !empty($mapper->importOK) ? '
						<table border="0" cellpadding="1" cellspacing="1" width="100%">
							'.implode('
							',$row).'
						</table>
					' : '',
					'description' => $LANG->getLL('f1.tab4.description'),
					'linkTitle' => '',
					'toggle' => 0,
					'stateIcon' => ($mapper->importNow == 'TRUE') ? -1 : 0
				);

			/***** TAB 4 data ********/

			/***** start ********/
			/***** import messages ********/
			/**** TAB 5 data *****/
				$row = array();

				$row[] = '
					<tr class="tableheader bgColor5">
						<td colspan="2">'.$LANG->getLL('f1.tab5').'</td>
					</tr>';

				$row[] = '
					<tr class="bgColor4">
						<td colspan=2>'.$msg.'</td>
					</tr>';

				$menuItems[] = array(
					'label' => $LANG->getLL('f1.tab5'),
					'content' => !empty($msg) ?
						'<table border="0" cellpadding="1" cellspacing="1" width="100%">
						'.implode('
						',$row).'
					</table>'
						: '',
	//					'description' => $LANG->getLL('f1.tab5.description'),
					'linkTitle' => '',
					'toggle' => 0,
					'stateIcon' => ($mapper->importNow == 'TRUE') ? 1 : 0
				);

			/***** TAB 5 data ********/

				// finally, print out the whole tabmenu
				//getDynTabMenu($menuItems,$identString,$toggle=0,$foldout=FALSE,$newRowCharLimit=50,$noWrap=1,$fullWidth=FALSE,$defaultTabIndex=1)
				$content = $this->doc->getDynTabMenu($menuItems,'tx_rsuserimp_import',0,'',40);
				$this->content .= $content;
				break;
			}
		}

		/**
 * Get IDs for allowed fe_users storage. These IDs are needed later on to create a dropdown selector.
 * Allowed in this respect means that the module fe_users is installed on that page.
 * The IDs are queried from the DB.
 *
 * @return	array
 */
		function getFEuserFolder () {
			$feFolders = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'uid,title',
					'pages',
					'module = "fe_users" AND deleted=0',
					'',
					'uid'
				);
			return $feFolders;
		}

		/**
 * Get IDs for valid fe_groups. These IDs are needed to create  dropdown selectors.
 * The IDs are queried from the DB.
 *
 * @return	array
 */
		function getFEuserGroup () {
			$importUserGroup = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'uid,title,description',
					'fe_groups',
					'deleted=0',
					'',
					'title'
				);
			return $importUserGroup;
		}

		/**
 * Gets all rollback datasets from DB.
 *
 * @return	array		returns the session dataset as array
 */
		function getRollbackDataSets () {

			global $BE_USER;

			$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'*',
					'tx_rsuserimp_sessions',
					'user_uid='.$BE_USER->user['uid'].' AND DELETED=0',
					'uid DESC',
					''
				);
			return $result;
		}

		/**
 * Gets a single rollback datasets from DB.
 *
 * @param	integer		$uid: the session UID
 * @return	string		returns the session dataset as list
 */
		function getRollbackDataSet ($uid) {

			global $BE_USER;

			list($result) = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'session_data',
					'tx_rsuserimp_sessions',
					'uid='.intval($uid)
				);
			return $result;
		}

		/**
 * Creates and returns a HTML select box prefilled with allowed DB column names.
 * This select box is needed for the CSV to DB field mapping process. Each select box is named by the passed integer.
 *
 * @param	integer		name for the select box
 * @return	string		formated HTML select box with DB column names
 */
		function fieldSelector($n) {

			$box = '<select name="fieldmap['.$n.']" '.$disabled.' size="1">'."\n";
			$box .= '<option value="">Zuordnung...</option>'."\n";
			foreach ($this->columnNamesFromDB as $key => $value) {
				$box.='<option value="' . $value. '"';
				if ($inData['fieldmap'][$n] == $value) {
					$box .= ' SELECTED ';
				}
				$box .= '>' . $value. '</option>'."\n";
			}
			$box.='</select>'."\n";
			return $box;
		}

		/**
 * Checks if a file has been uploaded and returns the complete physical fileinfo if so.
 *
 * @return	string		the complete physical file name, including path info.
 */
		function checkUpload()	{

			global $FILEMOUNTS,$TYPO3_CONF_VARS,$BE_USER;

			$file = t3lib_div::_GP('file');
			$inData = t3lib_div::_GP('tx_rsuserimp');

			// Initializing:
			$this->fileProcessor = t3lib_div::makeInstance('t3lib_extFileFunctions');
			$this->fileProcessor->init($FILEMOUNTS, $TYPO3_CONF_VARS['BE']['fileExtensions']);
			$this->fileProcessor->init_actionPerms($BE_USER->user['fileoper_perms']);
			$this->fileProcessor->dontCheckForUnique = ($inData['preset']['overwriteExistingFiles']) ? 1 : 0;

			// Checking referer / executing:
			$refInfo = parse_url(t3lib_div::getIndpEnv('HTTP_REFERER'));
			$httpHost = t3lib_div::getIndpEnv('TYPO3_HOST_ONLY');

			if ($httpHost != $refInfo['host'] && $this->vC != $BE_USER->veriCode() && !$TYPO3_CONF_VARS['SYS']['doNotCheckReferer'])	{
				$this->fileProcessor->writeLog(0,2,1,'Referer host "%s" and server host "%s" did not match!',array($refInfo['host'],$httpHost));
			} else {
				$this->fileProcessor->start($file);
				$newfile = $this->fileProcessor->func_upload($file['upload']['1']);
			}
			return $newfile;
		}

		/**
 * Select valid import and mapping presets for this user from DB.
 *
 * @return	array		array of preset records
 */
		function getPresets() {

			$presets = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'*',
					'tx_rsuserimp_presets',
					'user_uid='.intval($GLOBALS['BE_USER']->user['uid']),
					'',
					'title'
				);
			return $presets;
		}

		/**
 * Manipulates import and mapping presets
 *
 * @param	array		In data array, passed by reference!
 * @return	void
 */
		function processPresets(&$inData)	{

			global $LANG;

			$presetData = t3lib_div::_GP('tx_rsuserimp');
			$err = FALSE;

				// Save preset
			if (isset($presetData['preset']['save']))	{
				$preset = $this->getPreset($presetData['preset']['select']);
				if (is_array($preset))	{	// Update existing
					if ($GLOBALS['BE_USER']->isAdmin() || $preset['user_uid'] === $GLOBALS['BE_USER']->user['uid'])	{
						$fields_values = array(
							'title' => $inData['preset']['savetitle'],
							'preset_data' => serialize($inData)
						);
						$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_rsuserimp_presets','uid='.intval($preset['uid']),$fields_values);
						$msg = sprintf($LANG->getLL('f1.tab2.section.presets.save.created'),$preset['uid']);
	//					'Preset #'.$preset['uid'].' saved!';
					} else {
						$msg = $LANG->getLL('f1.tab2.section.presets.save.notOwner');
						$err = TRUE;
					}
				} else {	// Insert new:
					$fields_values = array(
						'user_uid' => $GLOBALS['BE_USER']->user['uid'],
						'title' => $inData['preset']['savetitle'],
						'preset_data' => serialize($inData)
					);
					$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_rsuserimp_presets',$fields_values);
					$msg = sprintf($LANG->getLL('f1.tab2.section.presets.save.created'),$inData['preset']['savetitle']);
				}
			}

				// Delete preset:
			if (isset($presetData['preset']['delete']))	{
				$preset = $this->getPreset($presetData['preset']['select']);
				if (is_array($preset))	{	// Update existing
					if ($GLOBALS['BE_USER']->isAdmin() || $preset['user_uid'] === $GLOBALS['BE_USER']->user['uid'])	{
						$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_rsuserimp_presets','uid='.intval($preset['uid']));
							$msg = sprintf($LANG->getLL('f1.tab2.section.presets.delete.deleted'),$preset['title'],$presetData['preset']['select']);
							$inData['preset']['select'] = '0';
					} else {
						$msg = $LANG->getLL('f1.tab2.section.presets.delete.notOwner');
						$err = TRUE;
					}
				} else {
					$msg = $LANG->getLL('f1.tab2.section.presets.delete.noSelection');
					$err = TRUE;
				}
			}

				// Load preset
			if (isset($presetData['preset']['load']) || isset($presetData['preset']['merge']))	{
				$preset = $this->getPreset($presetData['preset']['select']);
				if (is_array($preset))	{	// Update existing
					$inData_temp = unserialize($preset['preset_data']);
					if (is_array($inData_temp))	{
						if (isset($presetData['preset']['merge']))	{
								// Merge records in:
							if (is_array($inData_temp['record']))	{
								$inData['record'] = array_merge((array)$inData['record'], $inData_temp['record']);
							}
								// Merge lists in:
							if (is_array($inData_temp['list']))	{
								$inData['list'] = array_merge((array)$inData['list'], $inData_temp['list']);
							}
						} else {
							$msg = sprintf($LANG->getLL('f1.tab2.section.presets.load.loaded'),$preset['title'],$preset['uid']);
							$inData = $inData_temp;
						}
					} else {
						$msg = $LANG->getLL('f1.tab2.section.presets.load.noData');
						$err = TRUE;
					}
				} else {
					$msg = $LANG->getLL('f1.tab2.section.presets.load.noSelection');
					$err = TRUE;
				}
			}
				// Show message:
			if (strlen($msg))	{
				$this->content.= $this->doc->section($LANG->getLL('f1.tab2.section.presets'),$msg,0,1,$err ? 3 : 1);
			}
		}

		/**
 * Gets single import/mapping preset from DB.
 *
 * @param	integer		Preset record
 * @return	array		Preset record, if any (otherwise false)
 */
		function getPreset($uid)	{
			list($preset) = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*','tx_rsuserimp_presets','uid='.intval($uid));
			return $preset;
		}

		/*****************************
		 *
		 * Generel Helper functions
		 *
		 *****************************/

		/**
 * Returns first temporary folder of the user account (from $FILEMOUNTS)
 *
 * @return	string		Absolute path to first "_temp_" folder of the current user, otherwise blank.
 */
		function userTempFolder() {

			global $FILEMOUNTS;

			foreach($FILEMOUNTS as $filePathInfo) {
				$tempFolder = $filePathInfo['path'].'_temp_/';
				if (@is_dir($tempFolder))	{
					return $tempFolder;
				}
			}
		}

		/**
 * Create configuration save form
 *
 * @param	array		Form configuration data retrieved from GP data
 * @param	array		Table row accumulation variable. This is filled with table rows.
 * @return	void		Sets content in $this->content
 */
		function makeSaveForm($inData, &$row) {

			global $LANG;

			// Presets:
			$row[] = '
				<tr class="tableheader bgColor5">
					<td colspan="2">'.$LANG->getLL('f1.tab2.section.presets',1).'</td>
				</tr>';

			$presets = $this->getPresets();

			$opt = array('');
			if (is_array($presets))	{
				foreach($presets as $presetCfg)	{
					$opt[$presetCfg['uid']] = $presetCfg['title'].' ['.$presetCfg['uid'].']';
//													($presetCfg['public'] ? ' [Public]' : '').
//													($presetCfg['user_uid']===$GLOBALS['BE_USER']->user['uid'] ? ' [Own]' : '');
				}
			}

			$row[] = '
					<tr class="bgColor4">
						<td><strong>'.$LANG->getLL('f1.tab2.section.presets.load',1).'</strong></td>
						<td>
							<class="tableheader bgColor4">'.$LANG->getLL('f1.tab2.section.presets.load.select',1).'</class><br/>
							'.$this->renderSelectBox('tx_rsuserimp[preset][select]',($inData['preset']['select'] ?
							/*******************/
							//javascript to check fields swapPresetSelectFields()
							/*******************/
							$inData['preset']['select'] : ''),$opt,'swapfield').'
							<br/>
							<input type="submit" value="'.$LANG->getLL('f1.tab2.section.presets.load.load',1).'" name="tx_rsuserimp[preset][load]" '.($_POST['importNow'] ? 'disabled' : '').'/>
							<input type="submit" value="'.$LANG->getLL('f1.tab2.section.presets.load.delete',1).'" name="tx_rsuserimp[preset][delete]" onclick="return confirm(\''.$LANG->getLL('f1.tab2.section.presets.load.delete.sure',1).'\');" '.($_POST['importNow'] ? 'disabled' : '').'/>
						</td>
					</tr>
					<tr class="bgColor4">
						<td><strong>'.$LANG->getLL('f1.tab2.section.presets.save',1).'</strong></td>
						<td>
							'.$LANG->getLL('f1.tab2.section.presets.save.label',1).'<br/>
							'.$LANG->getLL('f1.tab2.section.presets.save.name',1).'
							<input type="text" name="tx_rsuserimp[preset][savetitle]" value="'.htmlspecialchars($inData['preset']['savetitle']).'" '.($_POST['importNow'] ? 'disabled' : '').'/><br/>'.
//							.$LANG->getLL('f1.tab2.section.presets.save.public',1).
//							'<input type="checkbox" name="tx_rsuserimp[preset][public]" value="1"'.($inData['preset']['public'] ? ' checked="checked"' : '').' '.($_POST['importNow'] ? 'disabled' : '').'/><br/>
							'<div align="right"><input type="submit" value="'.$LANG->getLL('f1.tab2.section.presets.save.save',1).'" name="tx_rsuserimp[preset][save]" onclick="return swapPresetSelectFields();" '.($_POST['importNow'] ? 'disabled' : '').'/></div>
						</td>
					</tr>';
		}

		/**
 * Returns a selector-box
 *
 * @param	string		Form element name prefix
 * @param	array		All possible values
 * @param	array		Current values selected
 * @param	string		alter behaviour
 * @return	string		HTML select element
 */
		function renderMultipleSelector($prefix,$allValues,$postData,$reverse=0)	{

			global $LANG;

if ($reverse) {
//print_r('entering reverse mode<br>');

			$optValues = array();
			if (!empty($postData)) {
				$optValues = $postData;
			}
//print_r('Option values<br>');
//print_a($optValues);
//print_r('<br>allvalues as per function call<br>');
//print_a($allValues);


} else {
//print_r('entering normal mode<br>');
//normal behaviour
			$optValues = array();
			if (!empty($postData)) {
				while(list($k,$v) = each($postData)) {
					$optValues[$v] = $v;
				}
			}
}

				// make box:
			$opt = array();
//			if (!$reverse) { $opt[] = '<option value="">&nbsp;</option>'; }
			reset($optValues);

			while(list($k,$v)=each($allValues))	{
				if (is_array($optValues))	{
					if ($reverse) {
						$sel = in_array($k,$optValues)?' selected="selected"':'';
					} else {
						$sel = in_array($v,$optValues)?' selected="selected"':'';
					}
				}
				if ($reverse) {
//print_r('entering reverse mode<br>');
					$opt[] = '<option value="'.htmlspecialchars($k).'"'.$sel.'>'.htmlspecialchars($v).'</option>';
				} else {
//print_r('entering normal mode<br>');
					$opt[] = '<option value="'.htmlspecialchars($v).'"'.$sel.'>'.htmlspecialchars($v).'</option>';
				}
			}
			return '<select name="'.$prefix.'[]" multiple="multiple" size="'.t3lib_div::intInRange(count($opt),2,6).'">'.implode('',$opt).'</select>';
		}

		/**
 * Makes a selector-box from optValues
 *
 * $this->renderSelectBox('tx_rsuserimp[pagetree][levels]',$inData['pagetree']['levels'],$opt)
 *
 * @param	string		Form element name
 * @param	string		Current value
 * @param	array		Options to display (key/value pairs)
 * @param	string		Optional ID value (needed for javascript swapfield() function
 * @return	string		HTML select element
 */
		function renderSelectBox($prefix,$value,$optValues,$id='') {

			$opt = array();
			$isSelFlag = 0;
			reset($optValues);
			while(list($k,$v) = each($optValues))	{
				$sel = (!strcmp($k,$value) ? ' selected="selected"' : '');
				if ($sel)	$isSelFlag++;
				$opt[] = '<option value="'.htmlspecialchars($k).'"'.$sel.'>'.htmlspecialchars($v).'</option>';
			}
			if (!$isSelFlag && strcmp('',$value))	{
				$opt[] = '<option value="'.htmlspecialchars($value).'" selected="selected">'.htmlspecialchars("['".$value."']").'</option>';
			}
			return '<select id="'.$id.'" name="'.$prefix.'" '.($_POST['importNow'] ? 'disabled' : '').'>'.implode('',$opt).'</select>';
		}

		/**
 * Garbage collection: deactivates aged out sessions and deletes no longer needed session data
 *
 * @param	[type]		$garbageCollectionTriggerTime: ...
 * @param	[type]		$rollbackSafetyTimespan: ...
 * @return	void
 */
		function gc($garbageCollectionTriggerTime,$rollbackSafetyTimespan) {

			global $BE_USER, $FILEMOUNTS, $TYPO3_CONF_VARS;

			$now = mktime();

			if (TYPO3_DLOG) {
				t3lib_div::devLog('Entering garbage collection routine at '.strftime("%d.%m.%Y - %H:%M:%S",$now), 'rs_userimp',-1);
			}

			if ($garbageCollectionTriggerTime == 0) {
				t3lib_div::devLog('TriggerTimer disabled, exiting garbage collection', 'rs_userimp',1);
				t3lib_div::devLog('Leaving garbage collection routine at '.strftime("%d.%m.%Y - %H:%M:%S",mktime()), 'rs_userimp',-1);
				return;
			} else {
				$garbageCollectionTriggerTime = $garbageCollectionTriggerTime * 24 * 60 * 60; //time in days
			}

			$rollbackData = $this->getRollbackDataSets();

			if (!empty($rollbackData)) {
				foreach ($rollbackData as $session) {
					if (TYPO3_DLOG) {
						t3lib_div::devLog('Session '.$session['uid'].' created '.strftime("%d.%m.%Y - %H:%M:%S",$session['crdate']), 'rs_userimp',-1);
					}

					if ($rollbackSafetyTimespan == 0) {
						if (TYPO3_DLOG) {
							t3lib_div::devLog('Rollback safety timer disabled', 'rs_userimp',-1);
						}
					 } else {
						$ageOutTime = $session['crdate']+60*$rollbackSafetyTimespan;
						if (TYPO3_DLOG) {
							t3lib_div::devLog('Age out timer for session '.$session['uid'].' set to '.strftime("%d.%m.%Y - %H:%M:%S",$ageOutTime), 'rs_userimp',-1);
							t3lib_div::devLog('Delete timer for session '.$session['uid'].' set to '.strftime("%d.%m.%Y - %H:%M:%S",$garbageCollectionTriggerTime+$session['crdate']), 'rs_userimp',-1);
						}
					 }
					if (($ageOutTime < $now) && $session['active'] ) {
						$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_rsuserimp_sessions','uid='.$session['uid'],array('active'=>'0'));
						t3lib_div::devLog('Inactivated aged out session '.$session['uid'], 'rs_userimp',1);
					}
				}
			}
			$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows(
					'uid,crdate,dropfile',
					'tx_rsuserimp_sessions',
					'user_uid='.$BE_USER->user['uid'].' AND active=0',
					'uid DESC',
					''
				);

			if (!empty($result)) {
				foreach ($result as $session) {
					if ( ($session['crdate']+$garbageCollectionTriggerTime) <= $now) {
						$GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_rsuserimp_sessions','uid='.$session['uid'],array('deleted'=>'1'));
						t3lib_div::devLog('Deleted aged out session '.$session['uid'], 'rs_userimp',1);
						if ($session['dropfile'] && t3lib_div::validPathStr($session['dropfile']) && t3lib_div::isFirstPartOfStr($session['dropfile'],PATH_site.'uploads/tx_rsuserimp/') ) {
							if (is_file($session['dropfile']) && @unlink($session['dropfile'])) {
								t3lib_div::devLog('Deleted drop file '.$session['dropfile'], 'rs_userimp',1);
							} else {
								t3lib_div::devLog('Unable to delete drop file '.$session['dropfile'].' (file not found?).', 'rs_userimp',3);
							}
						}
					}
				}
			}

			if (TYPO3_DLOG) {
				t3lib_div::devLog('Leaving garbage collection routine at '.strftime("%d.%m.%Y - %H:%M:%S",mktime()), 'rs_userimp',-1);
			}
			return;
		}
	} //end class definition

	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/rs_userimp/mod1/index.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/rs_userimp/mod1/index.php"]);
	}

	// Make instance:
	$SOBE = t3lib_div::makeInstance("tx_rsuserimp_module1");
	$SOBE->init();

	// Include files?
	foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

	$SOBE->main();
	$SOBE->printContent();
?>